/*********************************************************************
* 	WarpSharpMT for AviUtl
* 								ver. 1.33
* 
* AviSynthłWarpSharpGPL炵̂ŁAGPLɂȂ܂B
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
* http://www.gnu.org/copyleft/gpl.html .
* 
* 
* ===== WarpSharp for AviUtl ======
* [2003]
* 	10/19:	J(0.01)
* 			ŉ[ɃS~ooOC(0.01a)
* [2004]
* 	01/10:	Cubic4Tableł̖ʂȍČvZ
* 	01/12:	K͈͂̐ݒǉ(0.02)
* 
* ===== WarpSharpMT for AviUtl ===========
* [2008]
* 	06/22:	MT (1.00)
* 			ڂ̍ŉE[̌vZ~X(QƈʒuԈႢ)oOC
*			K͈͂TCYȏɂƗoOC
*			Cubic4Table𖈃t[ČvZĂ̂
*	06/24:	SSE2gp (1.10)
*			I[o[t[̂bump256255ɕύX(depth͂)
*	07/03:	WarpSharp̍XV(0.03)ɒǏ] (1.20)
*			Kp͈͂̐Â̂C(WarpSharp0.03甽f)
*			Kp͈͐ݒ̍őlg(WarpSharp0.03甽f)
*	07/20:	SIMDQƂǁA (1.30)
*			萔̐𖈉񂵂Ă̂
*			Warpsharp֐̐l~XC (BS̉ǔł甽f)
*			Bump̍ (BS̉ǔłQlɂĂ܂)
*			O̍EςƗĂ̂C 
*	07/21:	I[o[t[oOC (1.31)
*			c1080ŗĂ̂C (1.32)
*	07/23:	2`3sڂȂĂ̂C (1.33)
*			InterpolateCubic0-4096ɃNbvƃIWiƈĂ܂̂ŁAlœւ
*			
* 
*********************************************************************/
#define DEBUG
#define SSE2	//ꉞ邯OFFɂĂSSE2g܂BR[hQlcp
#ifdef SSE2
#define PREBUMP_SSE2
#define BLURROW_SSE2
#define BLURCOL_SSE2
#define WARPSHARP_SSE2
#endif

#define BUMP_NEW

#include <windows.h>
#include <math.h>
#ifdef SSE2
#include <intrin.h>
#endif
#include "filter.h"


//--------------------------------------------------------------------
//	class Cubic4Table	warpsharp.h
//--------------------------------------------------------------------
class Cubic4Table {
	int table[1024];
	int a;

public:
	Cubic4Table(int _a =-6)
	{
		a = _a+1;
		SetTable(_a);
	}

	void SetTable(int _a)
	{
		if(a==_a) return;

		a = _a;

		double A = (double)_a / 10;
		for(int i=0; i<256; i++) {
			double d = (double)i / 256.0;
			int y1, y2, y3, y4, ydiff;

			// Coefficients for all four pixels *must* add up to 1.0 for
			// consistent unity gain.
			//
			// Two good values for A are -1.0 (original VirtualDub bicubic filter)
			// and -0.75 (closely matches Photoshop).

			y1 = (int)floor(0.5 + (      + A*d -       2.0*A*d*d +       A*d*d*d) * 16384.0);
			y2 = (int)floor(0.5 + (+ 1.0       -     (A+3.0)*d*d + (A+2.0)*d*d*d) * 16384.0);
			y3 = (int)floor(0.5 + (      - A*d + (2.0*A+3.0)*d*d - (A+2.0)*d*d*d) * 16384.0);
			y4 = (int)floor(0.5 + (            +           A*d*d -       A*d*d*d) * 16384.0);

			// Normalize y's so they add up to 16384.

			ydiff = (16384 - y1 - y2 - y3 - y4)/4;
//			assert(ydiff > -16 && ydiff < 16);

			y1 += ydiff;
			y2 += ydiff;
			y3 += ydiff;
			y4 += ydiff;

//			if (mmx_table) {
//				table[i*4 + 0] = (y2<<16) | (y1 & 0xffff);
//				table[i*4 + 1] = (y4<<16) | (y3 & 0xffff);
//				table[i*4 + 2] = table[i*4 + 3] = 0;
//			} else {
				table[i*4 + 0] = y1;
				table[i*4 + 1] = y2;
				table[i*4 + 2] = y3;
				table[i*4 + 3] = y4;
//			}
		}
	}

	const int *GetTable() const
	{ return table; }

	operator int* (void)
	{ return table; }
};

//--------------------------------------------------------------------
//	class DefaultPicture
//--------------------------------------------------------------------
class DefaultPicture {
	PIXEL_YC* ycp_edit;
	PIXEL_YC* ycp_temp;
	int       h,w;
public:
	DefaultPicture(){  }
	DefaultPicture(const FILTER_PROC_INFO* fpip)
	{
		ycp_edit = fpip->ycp_edit;
		ycp_temp = fpip->ycp_temp;
		h = fpip->h;
		w = fpip->w;
	}

	void Store(FILTER_PROC_INFO* fpip)
	{
		fpip->ycp_edit = ycp_edit;
		fpip->ycp_temp = ycp_temp;
		fpip->h = h;
		fpip->w = w;
	}
	void ExchangeStore(FILTER_PROC_INFO* fpip)
	{
		fpip->ycp_edit = ycp_temp;
		fpip->ycp_temp = ycp_edit;
		fpip->h = h;
		fpip->w = w;
	}
};

typedef struct {
	FILTER				*fp;
	FILTER_PROC_INFO	*fpip;
} FILTER_PARAM;

typedef struct {
	short	*dst;
	short	*buf;
} BLUR_PARAM;

#ifdef BUMP_NEW
typedef struct {
	short	*bump;
	short	*buf_x;
	short	*buf_y;
} BUMP_PARAM;
#endif

//----------------------------
//	O[oϐ
//----------------------------
// 萔
const int radius = 2;	// ڂa
const int kernel = radius * 2 + 1;	// ڂ͈
int fixed_w;

static Cubic4Table cubic;

#ifdef SSE2
//8P(16rbg)SSE2p萔
static const __m128i c3 = {3,0, 3,0, 3,0, 3,0,  3,0, 3,0, 3,0, 3,0};			// 3 *8
static const __m128i c5 = {5,0, 5,0, 5,0, 5,0,  5,0, 5,0, 5,0, 5,0};			// 5 *8
static const __m128i c6 = {6,0, 6,0, 6,0, 6,0,  6,0, 6,0, 6,0, 6,0};			// 6 *8
static const __m128i c8 = {8,0, 8,0, 8,0, 8,0,  8,0, 8,0, 8,0, 8,0};			// 8 *8
static const __m128i c11 = {11,0, 11,0, 11,0, 11,0,  11,0, 11,0, 11,0, 11,0};	// 11 *8
static const __m128i c4095 = {0xFF,0x0F, 0xFF,0x0F, 0xFF,0x0F, 0xFF,0x0F, 0xFF,0x0F, 0xFF,0x0F, 0xFF,0x0F, 0xFF,0x0F};	// 0x0FFF(4095) *8
//4P(32rbg)SSE2p萔
static const __m128i c1_32 = {1,0,0,0, 1,0,0,0, 1,0,0,0, 1,0,0,0};				// 1 * 4
static const __m128i c128_32 = {128,0,0,0, 128,0,0,0, 128,0,0,0, 128,0,0,0};	// 128 *4
static const __m128i c255_32 = {255,0,0,0, 255,0,0,0, 255,0,0,0, 255,0,0,0};	// 255 *4
static const __m128i c1024_32 = {0,4,0,0, 0,4,0,0, 0,4,0,0, 0,4,0,0};			// 1024 *4
static const __m128i s256_32 = {0,0,0,0, 0,1,0,0, 0,2,0,0, 0,3,0,0};			// 0, 256, 512, 768
#endif

//----------------------------
//	vg^Cv
//----------------------------
inline int InterpolateCubic(const PIXEL_YC* src,int pitch,const int *qh,const int *qv);
//inline int AviUtlY(int y){ return ((y-15)*16 * 256 +110) / 220; }
static void  CopyEdge(FILTER *fp,FILTER_PROC_INFO *fpip);

// MT֐
#ifdef BUMP_NEW
static void PreBump(short *dst_x, short *dst_y, const PIXEL_YC *src, const FILTER_PROC_INFO* fpip, int y_start, int y_end);
static void PreBump_MT(int thread_id,int thread_num,void *param1,void *param2);
static void Bump(short *dst, const short *src_x, const short *src_y, const FILTER_PROC_INFO* fpip,int bump, int y_start, int y_end);
#else
static void Bump(short *dst,const PIXEL_YC *src,const FILTER_PROC_INFO* fpip,int bump, int y_start, int y_end);
#endif
static void Bump_MT(int thread_id,int thread_num,void *param1,void *param2);
static void BlurRow(short *dst, short* src, const FILTER_PROC_INFO* fpip, int y_start, int y_end);
static void BlurRow_MT(int thread_id,int thread_num,void *param1,void *param2);
static void BlurCol(short *dst, short* buf, const FILTER_PROC_INFO* fpip, int y_start, int y_end);
static void BlurCol_MT(int thread_id,int thread_num,void *param1,void *param2);
static void WarpSharp(short *bum, const FILTER *fp, const FILTER_PROC_INFO* fpip, int y_start, int y_end);
static void WarpSharp_MT(int thread_id,int thread_num,void *param1,void *param2);
static BOOL NegaPosi(FILTER *fp,FILTER_PROC_INFO *fpip, int y_start, int y_end);
static void NegaPosi_MT(int thread_id,int thread_num,void *param1,void *param2);

#ifdef SSE2
inline __m128i mm_mul4_epi32(__m128i a, __m128i b);
#endif

//----------------------------
//	FILTER_DLL\
//----------------------------
char filtername[] = "WarpSharpMT";
char filterinfo[] = "WarpSharpMT for AviUtl ver 1.33 by ";
#define track_N 8
#if track_N
TCHAR *track_name[]   = { "depth", "blur", "bump", "cubic", "", "", "", "E"};	// gbNo[̖O
int   track_default[] = {    128 ,     3 ,   128 ,     -6 ,   0 ,   0 ,   0 ,   0 };	// gbNo[̏l
int   track_s[]       = {      0 ,     1 ,     0 ,    -50 ,   0 ,   0 ,   0 ,   0 };	// gbNo[̉l
int   track_e[]       = {    255 ,     9 ,   255 ,     50 , 512 , 512 , 512 , 512 };	// gbNo[̏l
#endif

#define check_N 1
#if check_N
TCHAR *check_name[]   = { "͈͕\" };	// `FbN{bNX
int   check_default[] = {  0 };	// ftHg
#endif

#define tDEPTH  0
#define tBLUR   1
#define tBUMP   2
#define tCUBIC  3
#define tTOP    4
#define tBTM    5
#define tLEFT   6
#define tRIGHT  7
#define cDISP   0


FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION,
	NULL,NULL,      	// ݒEChẼTCY
	filtername,     	// tB^̖O
	track_N,        	// gbNo[̐
#if track_N
	track_name,     	// gbNo[̖OS
	track_default,  	// gbNo[̏lS
	track_s,track_e,	// gbNo[̐l̉
#else
	NULL,NULL,NULL,NULL,
#endif
	check_N,      	// `FbN{bNX̐
#if check_N
	check_name,   	// `FbN{bNX̖OS
	check_default,	// `FbN{bNX̏lS
#else
	NULL,NULL,
#endif
	func_proc,   	// tB^֐
	NULL,NULL,   	// Jn,IɌĂ΂֐
	func_update,   	// ݒ肪ύXꂽƂɌĂ΂֐
	func_WndProc,	// ݒEBhEvV[W
	NULL,NULL,   	// VXeŎgp
	NULL,NULL,   	// gf[^̈
	filterinfo,  	// tB^
	NULL,			// Z[uJnOɌĂ΂֐
	NULL,			// Z[uIɌĂ΂֐
	NULL,NULL,NULL,	// VXeŎgp
	NULL,			// g̈揉l
};

/*********************************************************************
*	DLL Export
*********************************************************************/
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}

//---------------------------------------------------------------------
//		tB^ݒύX֐
//---------------------------------------------------------------------
BOOL func_update( FILTER *fp, int status )
{
	// Cubic
	cubic.SetTable(fp->track[tCUBIC]);
	return TRUE;
}

/*====================================================================
*	tB^֐
*===================================================================*/
BOOL func_proc(FILTER *fp,FILTER_PROC_INFO *fpip)
{
	FILTER_PARAM	filter_param	= {fp, fpip};

	DefaultPicture defpic(fpip);

	if(fp->track[tTOP] || fp->track[tBTM] || fp->track[tLEFT] || fp->track[tRIGHT]){
		// ͈͎w肳Ă
		
		// O͈͂TCY𒴂Ăꍇ͏Ӗ
		if ((fp->track[tTOP] + fp->track[tBTM] >= fpip->h -3) || 
			(fp->track[tLEFT] + fp->track[tRIGHT] >= fpip->w -3)) {
			return FALSE;
		}

		CopyEdge(fp,fpip);	// ͈͊ORs[
		fpip->ycp_edit += fp->track[tLEFT] + fp->track[tTOP] * fpip->max_w;
		fpip->ycp_temp += fp->track[tLEFT] + fp->track[tTOP] * fpip->max_w;
		fpip->w        -= fp->track[tLEFT] + fp->track[tRIGHT];
		fpip->h        -= fp->track[tTOP]  + fp->track[tBTM];
	}

	if(fp->check[cDISP]){	// Kp͈͕\
		fp->exfunc->exec_multi_thread_func(NegaPosi_MT, (void *)fp, (void *)fpip);	// NegativePositive
		defpic.Store(fpip);
		return TRUE;
	}

	fixed_w = (fpip->w + 7) & (~7);	// 16Byte Aligned Width
	int alloc_size = fixed_w * fpip->h * sizeof(short);

	_MM_ALIGN16 short *bump = (short*)_aligned_malloc(alloc_size, 16);
	short *bum  = bump;

#ifdef BUMP_NEW
	//֊soƃobt@m
	_MM_ALIGN16 short *buf_x = (short*)_aligned_malloc(alloc_size, 16);
	_MM_ALIGN16 short *buf_y = (short*)_aligned_malloc(alloc_size, 16);

	// ֊so
	BUMP_PARAM bump_param = {bum, buf_x, buf_y};
	fp->exfunc->exec_multi_thread_func(PreBump_MT, (void *)&filter_param, (void *)&bump_param);
//	PreBump(buf_x, buf_y, fpip->ycp_edit, fpip, 0, fpip->h -1);
	fp->exfunc->exec_multi_thread_func(Bump_MT, (void *)&filter_param, (void *)&bump_param);
//	Bump(bum, buf_x, buf_y, fpip, fp->track[tBUMP]*16, 0, fpip->h -1);

	
	//֊soƃobt@
	_aligned_free(buf_x);
	_aligned_free(buf_y);
#else
	// ֊so
	fp->exfunc->exec_multi_thread_func(Bump_MT, (void *)&filter_param, (void *)bum);
#endif

	//ڂobt@m
	_MM_ALIGN16 short *buf = (short*)_aligned_malloc(alloc_size, 16);
	BLUR_PARAM	blur_param	= {bum, buf};
	
	for(int i=fp->track[tBLUR];i;--i) {	// wڂ
		//ڂ
		fp->exfunc->exec_multi_thread_func(BlurRow_MT, (void *)fpip, (void *)&blur_param);
//		BlurRow(buf, bum, fpip, 0, fpip->h -1);
		//cڂ
		fp->exfunc->exec_multi_thread_func(BlurCol_MT, (void *)fpip, (void *)&blur_param);
//		BlurCol(buf, bum, fpip, 0, fpip->h -1);
	}

	//ڂobt@
	_aligned_free(buf);

	// WarpSharp
	fp->exfunc->exec_multi_thread_func(WarpSharp_MT, (void *)&filter_param, (void *)bum);
//	WarpSharp(bum, fp, fpip, 0, fpip->h - 1);
	
	defpic.ExchangeStore(fpip);
/* test *
	for(i=0;i<fpip->h;i++){
		for(int j=0;j<fpip->w;j++){
			fpip->ycp_edit[i*fpip->max_w+j].y = bump[i*fpip->w+j];
		}
	}

//*/
	_aligned_free(bump);

	return TRUE;
}

#ifdef BUMP_NEW
/*--------------------------------------------------------------------
*	PreBump	֊soO	(MT)
*-------------------------------------------------------------------*/
static void PreBump(short *dst_x, short *dst_y, const PIXEL_YC *src, const FILTER_PROC_INFO* fpip, int y_start, int y_end)
{
	int sy1 = fpip->max_w;
	int sy2 = sy1 + fpip->max_w;
#ifdef PREBUMP_SSE2
	__m128i ds, s1, s2, s3, s4;
	int w_simd1 = (fpip->w < 8)? (fpip->w - 1): 8;
	int w_simd2 = (fpip->w & (~7)) -8;
#endif
	
	int proc_h = y_end - y_start +1;
	if (y_start != 0) {
		//[ȊO͏ʒuֈړ
		dst_x += fixed_w * y_start;
		dst_y += fixed_w * y_start;
		src += fpip->max_w * y_start;
	}else{
		//[̓XLbv
		dst_x += fixed_w;
		dst_y += fixed_w;
		src += fpip->max_w;
		proc_h--;
	}
	if (y_end >= fpip->h -1) {
		proc_h--;
	}
	const PIXEL_YC *src_head = src;
	
	//[0
	dst_x[0] = 0;
	//1s͒ʏWv
	for(int x=1; x<fpip->w -2; x++) {
		dst_x[x] =	+src[x-1 -sy1].y +src[x-1].y +src[x-1 +sy1].y
					-src[x+1 -sy1].y -src[x+1].y -src[x+1 +sy1].y;
	}
	//E[0
	dst_x[fpip->w -1] = 0;
	dst_x += fixed_w;
	src += fpip->max_w;

	for(int y=proc_h; y; y--) {
		//[0
		dst_x[0] = 0;
#ifdef PREBUMP_SSE2
		//̈ʒuƂ̍
		//128rbgEO
		for(int x=1; x<w_simd1; x++) {
			dst_x[x] = dst_x[x-fixed_w]	-src[x-1 -sy2].y +src[x-1 +sy1].y
										+src[x+1 -sy2].y -src[x+1 +sy1].y;
		}
		for(int x=w_simd1; x<w_simd2; x+=8) {
			ds = _mm_load_si128((__m128i *)&dst_x[x -fixed_w]);
			for(int i=0; i<8; i++) {
				s1.m128i_i16[i] = src[x-1 -sy2 +i].y;
				s2.m128i_i16[i] = src[x-1 +sy1 +i].y;
				s3.m128i_i16[i] = src[x+1 -sy2 +i].y;
				s4.m128i_i16[i] = src[x+1 +sy1 +i].y;
			}
			ds = _mm_sub_epi16(ds, s1);
			ds = _mm_add_epi16(ds, s2);
			ds = _mm_add_epi16(ds, s3);
			ds = _mm_sub_epi16(ds, s4);
//			_mm_store_si128((__m128i *)&dst_x[x], ds);
			_mm_stream_si128((__m128i *)&dst_x[x], ds);
		}
		//SIMDc
		for(int x=w_simd2; x<fpip->w -1; x++) {
			//̈ʒuƂ̍
			dst_x[x] = dst_x[x-fixed_w]	-src[x-1 -sy2].y +src[x-1 +sy1].y
										+src[x+1 -sy2].y -src[x+1 +sy1].y;
		}		
#else
		for(int x=1; x<fpip->w -1; x++) {
			//̈ʒuƂ̍
			dst_x[x] = dst_x[x-fixed_w]	-src[x-1 -sy2].y +src[x-1 +sy1].y
										+src[x+1 -sy2].y -src[x+1 +sy1].y;
		}
#endif
		//E[0
		dst_x[fpip->w -1] = 0;

		dst_x += fixed_w;
		src += fpip->max_w;
	}
	
	src = src_head;

	for(int y=proc_h; y; y--) {
		//[0
		dst_y[0] = 0;
		//ʏ폈
		dst_y[1] =	+src[-sy1].y + src[-sy1 +1].y + src[-sy1 +2].y
					-src[+sy1].y - src[+sy1 +1].y - src[+sy1 +2].y;
		for(int x=2; x<fpip->w -1; x++) {
			//̈ʒuƂ̍
			dst_y[x] = dst_y[x-1]	-src[x-2 -sy1].y +src[x-2 +sy1].y
									+src[x+1 -sy1].y -src[x+1 +sy1].y;
		}
		//E[0
		dst_y[fpip->w -1] = 0;

		dst_y += fixed_w;
		src += fpip->max_w;
	}
}
//}`Xbh
static void PreBump_MT(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER *fp				= ((FILTER_PARAM *)param1)->fp;
	FILTER_PROC_INFO *fpip	= ((FILTER_PARAM *)param1)->fpip;
	short *buf_x = ((BUMP_PARAM *)param2)->buf_x;
	short *buf_y = ((BUMP_PARAM *)param2)->buf_y;
	
	//摜cɃXbhď͈͌vZ
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = (( fpip->h * (thread_id+1) ) / thread_num) -1;

	PreBump(buf_x, buf_y, fpip->ycp_edit, fpip, y_start, y_end);
}

/*--------------------------------------------------------------------
*	Bump	֊so	(MT)
*-------------------------------------------------------------------*/
static void Bump(short *dst, const short *src_x, const short *src_y, const FILTER_PROC_INFO* fpip,int bump, int y_start, int y_end)
{
	__m128i dx, dy, si, msk, ds, v1, v2, lv;
	__m128i bp = _mm_set1_epi16(bump);
	int w_simd = (fpip->w &(~7)) -8;
	
	int proc_h = y_end - y_start +1;
	//ԏ0NA
	if (y_start != 0) {
		//XbhƂ̏ʒuɏC
		dst += y_start * fixed_w;
		src_x += y_start * fixed_w;
		src_y += y_start * fixed_w;
	}else{
		memset(dst,0,fpip->w * sizeof(*dst));
		dst += fixed_w;
		src_x += fixed_w;
		src_y += fixed_w;
		
		proc_h--;
	}
	if (y_end >= fpip->h -1) {
		proc_h--;
	}

	for(int i=proc_h;i;--i){
		for(int j=w_simd; j; j-=8) {
			// abs(dx)
			dx = _mm_load_si128((__m128i *)src_x);
			si = _mm_srai_epi16(dx, 15);
			dx = _mm_sub_epi16(_mm_xor_si128(dx, si), si);
			// abs(dy)
			dy = _mm_load_si128((__m128i *)src_y);
			si = _mm_srai_epi16(dy, 15);
			dy = _mm_sub_epi16(_mm_xor_si128(dy, si), si);
			// (dx + dy) *3
			v1 = _mm_min_epi16(_mm_add_epi32(dx, dy), c4095);	//4095ŃNbv
			v1 = _mm_mullo_epi16(v1, c3);
			// abs(dx -dy)
			v2 = _mm_sub_epi16(dx, dy);
			si = _mm_srai_epi16(v2, 15);
			v2 = _mm_sub_epi16(_mm_xor_si128(v2, si), si);
			// +
			lv = _mm_adds_epi16(v1, v2);
			//(level>bump) ? bump : level
			ds = _mm_min_epi16(lv, bp);
			
//			_mm_store_si128((__m128i *)dst, ds);
			_mm_stream_si128((__m128i *)dst, ds);
			
			dst += 8;
			src_x += 8;
			src_y += 8;
		}
		for(int j=fpip->w-w_simd; j; j--) {
			int level = 3*(abs(*src_x) + abs(*src_y)) + abs(abs(*src_x) - abs(*src_y));
			
			*dst = (level>bump) ? bump : level;
			
			dst++;
			src_x++;
			src_y++;
		}
		dst += fixed_w - fpip->w;
		src_x += fixed_w - fpip->w;
		src_y += fixed_w - fpip->w;
	}
	//ԉ0NA
	if (y_end >= fpip->h -1) {
		memset(dst,0,fpip->w*sizeof(*dst));
	}
}
//}`Xbh
static void Bump_MT(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER *fp				= ((FILTER_PARAM *)param1)->fp;
	FILTER_PROC_INFO *fpip	= ((FILTER_PARAM *)param1)->fpip;
	short *bum = ((BUMP_PARAM *)param2)->bump;
	short *buf_x = ((BUMP_PARAM *)param2)->buf_x;
	short *buf_y = ((BUMP_PARAM *)param2)->buf_y;
	
	//摜cɃXbhď͈͌vZ
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = (( fpip->h * (thread_id+1) ) / thread_num) -1;

	Bump(bum, buf_x, buf_y, fpip, fp->track[tBUMP]*16, y_start, y_end);
}
#else

/*--------------------------------------------------------------------
*	Bump	֊so	(MT)
*-------------------------------------------------------------------*/
static void Bump(short *dst,const PIXEL_YC *src, const FILTER_PROC_INFO* fpip,int bump, int y_start, int y_end)
{
	//XbhƂ̏ʒuɏC
	dst += y_start * fixed_w;
	src += y_start * fpip->max_w;
	int proc_h = y_end - y_start +1;
	
	//ԏ0NA
	if (y_start == 0) {
		memset(dst,0,fpip->w*sizeof(*dst));
		dst += fixed_w;
		src += fpip->max_w;
		
		proc_h--;
	}
	if (y_end >= fpip->h -1) {
		proc_h--;
	}

	for(int i=proc_h;i;--i){
		//[0NA
		*dst = 0;

		dst ++;
		src ++;
		for(int j=fpip->w-2;j;--j){
			int dx,dy;
			//dx = abs(++-E+E+E)
			dx = abs(src[-1-fpip->max_w].y + src[-1].y + src[-1+fpip->max_w].y
					- src[1-fpip->max_w].y - src[1].y - src[1+fpip->max_w].y);
			//dy = abs(++E---E)
			dy = abs(src[-fpip->max_w-1].y + src[-fpip->max_w].y + src[-fpip->max_w+1].y
					- src[fpip->max_w-1].y - src[fpip->max_w].y - src[fpip->max_w+1].y);

			int level = 3*(dx+dy) + abs(dx-dy);

			*dst = (level>bump) ? bump : level;

			dst += 1;
			src += 1;
		}
		//E[0NA
		*dst = 0;

		src += fpip->max_w - fpip->w +1;	//OXLbv
		dst += fixed_w - fpip->w +1;
	}
	//ԉ0NA
	if (y_end >= fpip->h -1) {
		memset(dst,0,fpip->w*sizeof(*dst));
	}
}
//}`Xbh
static void Bump_MT(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER *fp				= ((FILTER_PARAM *)param1)->fp;
	FILTER_PROC_INFO *fpip	= ((FILTER_PARAM *)param1)->fpip;
	short *bum = (short *)param2;
	
	//摜cɃXbhď͈͌vZ
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = (( fpip->h * (thread_id+1) ) / thread_num) -1;

	Bump(bum, fpip->ycp_edit, fpip, fp->track[tBUMP]*16, y_start, y_end);
}
#endif

//--------------------------------------------------------------------
//	BlurRow	ڂ
//--------------------------------------------------------------------
static void BlurRow(short *dst, short* src, const FILTER_PROC_INFO* fpip, int y_start, int y_end)
{
	const int rp = fpip->w - 2;
#ifdef BLURROW_SSE2
	const int x_simd = (rp &(~7)) -8;
	__m128i r, sx0, sx1, sx2, sx3, sx4, sx5;
#endif
	
	for(int y = y_start; y <= y_end; y++) {
		short *dst_r = dst + y * fixed_w;
		short *src_r = src + y * fixed_w;

		//[F[11]-4-1 / 5-[6]-4-1
		dst_r[0] = (src_r[0]*11 + src_r[1]*4 + src_r[2]              +8) >>4;
		dst_r[1] = (src_r[0]*5  + src_r[1]*6 + src_r[2]*4 + src_r[3] +8) >>4;
	
		//ʏ폈F1-4-[6]-4-1
#ifdef BLURROW_SSE2
		//8PSSE
		sx5 = _mm_load_si128((__m128i *)&src_r[0]);
		for(int x = 2; x < x_simd; x+=8) {
			sx0 = sx5;
			sx5 = _mm_load_si128((__m128i *)&src_r[x+6]);
			sx1 = _mm_srli_si128(sx0, 2);
			sx1.m128i_i16[7] = sx5.m128i_i16[0];
			sx2 = _mm_srli_si128(sx1, 2);
			sx2.m128i_i16[7] = sx5.m128i_i16[1];
			sx3 = _mm_srli_si128(sx2, 2);
			sx3.m128i_i16[7] = sx5.m128i_i16[2];
			sx4 = _mm_srli_si128(sx3, 2);
			sx4.m128i_i16[7] = sx5.m128i_i16[3];
			r = _mm_add_epi16(	sx0,
				_mm_add_epi16(	_mm_slli_epi16(sx1, 2),
				_mm_add_epi16(	_mm_mullo_epi16(sx2, c6),
				_mm_add_epi16(	_mm_slli_epi16(sx3, 2),
								sx4
				))));
			r = _mm_srli_epi16(_mm_add_epi16(r, c8), 4);	//+8 >>4
			_mm_storeu_si128((__m128i *)&dst_r[x], r);
		}
		//8PSSE]
		for(int x = x_simd; x < rp; x++) {
			dst_r[x] = (src_r[x-2] + src_r[x-1]*4 + src_r[x]*6 + src_r[x+1]*4 + src_r[x+2] +8) >>4;
		}
#else
		for(int x = 2; x < fpip->w -2; x++) {
			dst_r[x] = (src_r[x-2] + src_r[x-1]*4 + src_r[x]*6 + src_r[x+1]*4 + src_r[x+2] +8) >>4;
		}
#endif
	
		//E[F1-4-[6]-5 / 1-4-[11]
		dst_r[rp]   = (src_r[rp-2] + src_r[rp-1]*4 + src_r[rp]*6 + src_r[rp+1]*5  +8) >>4;
		dst_r[rp+1] = (              src_r[rp-1]   + src_r[rp]*4 + src_r[rp+1]*11 +8) >>4;
	}
}
//}`Xbh
static void BlurRow_MT(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER_PROC_INFO *fpip	= (FILTER_PROC_INFO *)param1;
	short *buf = ((BLUR_PARAM *)param2)->buf;
	short *dst = ((BLUR_PARAM *)param2)->dst;
	
	//摜cɃXbhď͈͌vZ
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = (( fpip->h * (thread_id+1) ) / thread_num) -1;
	
	BlurRow(buf, dst, fpip, y_start, y_end);
}

//--------------------------------------------------------------------
//	BlurCol	cڂ
//--------------------------------------------------------------------
static void BlurCol(short *dst, short* src, const FILTER_PROC_INFO* fpip, int y_start, int y_end)
{
	//esړ
	int y1 = fixed_w;
	int y2 = y1 + fixed_w;
	int y3 = y2 + fixed_w;
	int y4 = y3 + fixed_w;
	
#ifdef BLURCOL_SSE2
	const int w_simd = (fpip->w &(~7)) -8;
	__m128i sx0, sx1, sx2, sx3, sx4;
	__m128i r;
#endif
	int proc_h = y_end - y_start +1;
	
	if (y_start != 0) {
		//JnʒuɈړ
		dst += y_start * fixed_w;
		src += (y_start - 2) * fixed_w;
	}else{
		//[F[11]-4-1 / 5-[6]-4-1
#ifdef BLURCOL_SSE2
		for(int x=0; x<w_simd; x+=8) {
			sx0 = _mm_load_si128((__m128i *)&src[x]);
			sx1 = _mm_load_si128((__m128i *)&src[y1+x]);
			sx2 = _mm_load_si128((__m128i *)&src[y2+x]);
			sx3 = _mm_load_si128((__m128i *)&src[y3+x]);
			
			r =                  _mm_mullo_epi16(sx0, c11);		//*11
			r = _mm_add_epi16(r, _mm_slli_epi16( sx1, 2));		//*4
			r = _mm_add_epi16(r,                 sx2);			//*1
			r = _mm_srli_epi16(_mm_add_epi16(r, c8), 4);		//+8 >>4
//			_mm_store_si128((__m128i *)&dst[x], r);
			_mm_stream_si128((__m128i *)&dst[x], r);
			
			r =                  _mm_mullo_epi16(sx0, c5);		//*5
			r = _mm_add_epi16(r, _mm_mullo_epi16(sx1, c6));		//*6
			r = _mm_add_epi16(r, _mm_slli_epi16( sx2, 2));		//*4
			r = _mm_add_epi16(r,                 sx3);			//*1
			r = _mm_srli_epi16(_mm_add_epi16(r, c8), 4);		//+8 >>4
//			_mm_store_si128((__m128i *)&dst[y1+x], r);
			_mm_stream_si128((__m128i *)&dst[y1+x], r);
		}
		for(int x=w_simd; x<fpip->w; x++) {
			dst[x]    = (src[x]*11 + src[y1+x]*4 + src[y2+x]               +8) >>4;
			dst[y1+x] = (src[x]*5  + src[y1+x]*6 + src[y2+x]*4 + src[y3+x] +8) >>4;
		}
#else
		for(int x=0; x<fpip->w; x++) {
			dst[x]    = (src[x]*11 + src[y1+x]*4 + src[y2+x]               +8) >>4;
			dst[y1+x] = (src[x]*5  + src[y1+x]*6 + src[y2+x]*4 + src[y3+x] +8) >>4;
		}
#endif
		dst += y2;
		proc_h -= 2;
	}
	if (y_end >= fpip->h -1) {
		proc_h -= 2;
	}

	//ʏ폈F1-4-[6]-4-1
	for(int i=proc_h; i; i--) {
#ifdef BLURCOL_SSE2
		for(int x=0; x<w_simd; x+=8) {
			sx0 = _mm_load_si128((__m128i *)&src[x]);
			sx1 = _mm_load_si128((__m128i *)&src[y1+x]);
			sx2 = _mm_load_si128((__m128i *)&src[y2+x]);
			sx3 = _mm_load_si128((__m128i *)&src[y3+x]);
			sx4 = _mm_load_si128((__m128i *)&src[y4+x]);
			
			r = _mm_add_epi16(sx0, _mm_slli_epi16( sx1, 2));	//*1 + *4
			r = _mm_add_epi16(r,   _mm_mullo_epi16(sx2, c6));	//*6
			r = _mm_add_epi16(r,   _mm_slli_epi16( sx3, 2));	//*4
			r = _mm_add_epi16(r,                   sx4);		//*1
			r = _mm_srli_epi16(_mm_add_epi16(r, c8), 4);		//+8 >>4
//			_mm_store_si128((__m128i *)&dst[x], r);
			_mm_stream_si128((__m128i *)&dst[x], r);
		}
		for(int x=w_simd; x<fpip->w; x++) {
			dst[x] = (src[x] + src[y1+x]*4 + src[y2+x]*6 + src[y3+x]*4 + src[y4+x] +8) >>4;
		}
#else
		for(int x=0; x<fpip->w; x++) {
			dst[x] = (src[x] + src[y1+x]*4 + src[y2+x]*6 + src[y3+x]*4 + src[y4+x] +8) >>4;
		}
#endif
		dst += y1;
		src += y1;
	}

	if (y_end >= fpip->h -1) {
		//[F1-4-[6]-5 / 1-4-[11]
#ifdef BLURCOL_SSE2
		for(int x=0; x<w_simd; x+=8) {
			sx0 = _mm_load_si128((__m128i *)&src[x]);
			sx1 = _mm_load_si128((__m128i *)&src[y1+x]);
			sx2 = _mm_load_si128((__m128i *)&src[y2+x]);
			sx3 = _mm_load_si128((__m128i *)&src[y3+x]);

			r = _mm_add_epi16(sx0, _mm_slli_epi16( sx1, 2));	//*1 + *4
			r = _mm_add_epi16(r,   _mm_mullo_epi16(sx2, c6));	//*6
			r = _mm_add_epi16(r,   _mm_mullo_epi16(sx3, c5));	//*5
			r = _mm_srli_epi16(_mm_add_epi16(r, c8), 4);		//+8 >>4
//			_mm_store_si128((__m128i *)&dst[x], r);
			_mm_stream_si128((__m128i *)&dst[x], r);

			r = _mm_add_epi16(sx1, _mm_slli_epi16(sx2, 2));		//*1 + *4
			r = _mm_add_epi16(r, _mm_mullo_epi16( sx3, c11));	//*11
			r = _mm_srli_epi16(_mm_add_epi16(r, c8), 4);		//+8 >>4
//			_mm_store_si128((__m128i *)&dst[y1+x], r);
			_mm_stream_si128((__m128i *)&dst[y1+x], r);
		}
		for(int x=w_simd; x<fpip->w; x++) {
			dst[x]    = (src[x] + src[y1+x]*4 + src[y2+x]*6 + src[y3+x]*5  +8) >>4;
			dst[y1+x] = (         src[y1+x]   + src[y2+x]*4 + src[y3+x]*11 +8) >>4;
		}
#else
		for(int x=0; x<fpip->w; x++) {
			dst[x]    = (src[x] + src[y1+x]*4 + src[y2+x]*6 + src[y3+x]*5  +8) >>4;
			dst[y1+x] = (         src[y1+x]   + src[y2+x]*4 + src[y3+x]*11 +8) >>4;
		}
#endif
	}
}
//}`Xbh
static void BlurCol_MT(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER_PROC_INFO *fpip	= (FILTER_PROC_INFO *)param1;
	short *buf = ((BLUR_PARAM *)param2)->buf;
	short *dst = ((BLUR_PARAM *)param2)->dst;
	
	//摜cɃXbhď͈͌vZ
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = (( fpip->h * (thread_id+1) ) / thread_num) -1;
	
	BlurCol(dst, buf, fpip, y_start, y_end);
}

//--------------------------------------------------------------------
//	WarpSharp
//--------------------------------------------------------------------
static void WarpSharp(short *bum, const FILTER *fp, const FILTER_PROC_INFO* fpip, int y_start, int y_end)
{
	int depth = fp->track[tDEPTH];
	PIXEL_YC* dst = fpip->ycp_temp;
	const PIXEL_YC* src = fpip->ycp_edit;
#ifdef WARPSHARP_SSE2
	const int w_simd = (fpip->w -2) &(~7);
	__m128i lo_ym, hi_ym, lo_xm, hi_xm, bm1, bm2, dxm, dym, ssm, cxm, cym, msk;
	__m128i dpm = _mm_set1_epi32(depth);
	__m128i mwm = _mm_set1_epi32(fpip->max_w);
#endif
	int proc_h = y_end - y_start +1;
	int lo_dispy, hi_dispy;

	if (y_start != 0) {
		//XbhƂ̏ʒuɏC
		dst += y_start * fpip->max_w;
		src += y_start * fpip->max_w;
		bum += y_start * fixed_w;

		lo_dispy = (-y_start + 1) * 256;
		hi_dispy = (fpip->h - 3 - y_start + 1) *256 -1;
	}else{
		//[͂̂܂܃Rs[
		memcpy(dst,src,fpip->w*sizeof(*dst));
		dst += fpip->max_w;
		src += fpip->max_w;
		bum += fixed_w;
		
		proc_h--;

		lo_dispy = 0;
		hi_dispy = (fpip->h - 3) *256 -1;
	}
	if (y_end >= fpip->h -1) {
		proc_h--;
	}
	
	for(int h=proc_h; h; --h){
		*dst = *src;
		++bum; ++dst; ++src;

		int lo_dispx = 0;
		int hi_dispx = (fpip->w - 3) *256 -1;

#ifdef WARPSHARP_SSE2
		lo_ym = _mm_set1_epi32(lo_dispy);
		hi_ym = _mm_set1_epi32(hi_dispy);
		
		lo_xm = _mm_sub_epi32(_mm_setzero_si128(), s256_32);
		hi_xm = _mm_sub_epi32(_mm_set1_epi32(hi_dispx), s256_32);
		
		for(int x=1; x<w_simd; x+=8) {
			// dispx = bum[-1] - bum[1]
			bm1 = _mm_load_si128((__m128i *)&bum[-1]);
			bm2 = _mm_srli_si128(bm1, 4);
			bm2.m128i_i16[6] = bum[7];
			bm2.m128i_i16[7] = bum[8];
			dxm = _mm_sub_epi16(bm1, bm2);
			
			// dispy = bum[-fpip->w] - bum[fpip->w]
			bm1 = _mm_load_si128((__m128i *)&bum[-fixed_w -1]);
			bm1 = _mm_srli_si128(bm1, 2);
			bm1.m128i_i16[7] = bum[-fixed_w +7];
			bm2 = _mm_load_si128((__m128i *)&bum[+fixed_w -1]);
			bm2 = _mm_srli_si128(bm2, 2);
			bm2.m128i_i16[7] = bum[+fixed_w +7];
			dym = _mm_sub_epi16(bm1, bm2);
			
			// 16rbgł̓I[o[t[̂32rbg2ŏ
			__m128i dx32[] = {	_mm_setr_epi32(dxm.m128i_i16[0], dxm.m128i_i16[1], dxm.m128i_i16[2], dxm.m128i_i16[3]),
								_mm_setr_epi32(dxm.m128i_i16[4], dxm.m128i_i16[5], dxm.m128i_i16[6], dxm.m128i_i16[7]),
							};
			__m128i dy32[] = {	_mm_setr_epi32(dym.m128i_i16[0], dym.m128i_i16[1], dym.m128i_i16[2], dym.m128i_i16[3]),
								_mm_setr_epi32(dym.m128i_i16[4], dym.m128i_i16[5], dym.m128i_i16[6], dym.m128i_i16[7]),
							};
			for(int i=0; i<2; i++) {
				// dispx = (dispx * depth +128) >>8
				dx32[i] = _mm_srai_epi32(_mm_add_epi32(mm_mul4_epi32(dx32[i], dpm), c128_32), 8);
				dy32[i] = _mm_srai_epi32(_mm_add_epi32(mm_mul4_epi32(dy32[i], dpm), c128_32), 8);
				
				// lo_dispx < dispx < hi_dispx
				msk = _mm_cmpgt_epi32(dx32[i], lo_xm);
				dx32[i] = _mm_or_si128(_mm_and_si128(msk, dx32[i]), _mm_andnot_si128(msk, lo_xm));
				msk = _mm_cmplt_epi32(dx32[i], hi_xm);
				dx32[i] = _mm_or_si128(_mm_and_si128(msk, dx32[i]), _mm_andnot_si128(msk, hi_xm));

				msk = _mm_cmpgt_epi32(dy32[i], lo_ym);
				dy32[i] = _mm_or_si128(_mm_and_si128(msk, dy32[i]), _mm_andnot_si128(msk, lo_ym));
				msk = _mm_cmplt_epi32(dy32[i], hi_ym);
				dy32[i] = _mm_or_si128(_mm_and_si128(msk, dy32[i]), _mm_andnot_si128(msk, hi_ym));

				// ((dispx>>8)-1) + ((dispy>>8)-1) * fpip->max_w
				ssm = _mm_add_epi32(_mm_sub_epi32(_mm_srai_epi32(dx32[i], 8), c1_32),
						mm_mul4_epi32(_mm_sub_epi32(_mm_srai_epi32(dy32[i], 8), c1_32), mwm));
				
				//(dispx & 255) * 4;
				cxm = _mm_slli_epi32(_mm_and_si128(dx32[i], c255_32), 2);
				cym = _mm_slli_epi32(_mm_and_si128(dy32[i], c255_32), 2);
				
				for(int j=0; j<4; j++) {
					const PIXEL_YC* src2 = src + ssm.m128i_i32[j];
					const int *qh = (int*)cubic + cxm.m128i_i32[j];
					const int *qv = (int*)cubic + cym.m128i_i32[j];
					
					dst->y = InterpolateCubic(src2, fpip->max_w, qh, qv);
					dst->cb = src->cb;
					dst->cr = src->cr;

					++dst; ++src; ++bum;
					lo_dispx -= 256;
					hi_dispx -= 256;
				}
				// lo_dispx -= 256
				lo_xm = _mm_sub_epi32(lo_xm, c1024_32);
				hi_xm = _mm_sub_epi32(hi_xm, c1024_32);
			}
		}
		for(int x=w_simd +1; x<fpip->w -1; x++) {
#else
		for(int w=fpip->w-2; w; --w){
#endif
			int dispx = bum[-1] - bum[1];
			int dispy = bum[-fixed_w] - bum[fixed_w];

			dispx = (dispx * depth +128) >>8;// (dispx * depth +8) >>4;
			dispy = (dispy * depth +128) >>8;

			if(dispx < lo_dispx)      dispx = lo_dispx;
			else if(dispx > hi_dispx) dispx = hi_dispx;

			if(dispy < lo_dispy)      dispy = lo_dispy;
			else if(dispy > hi_dispy) dispy = hi_dispy;
			
			const PIXEL_YC* src2 = src + ((dispx>>8)-1) + ((dispy>>8)-1)*fpip->max_w;
			
			const int *qh = (int*)cubic + (dispx & 255) * 4;
			const int *qv = (int*)cubic + (dispy & 255) * 4;

			dst->y = InterpolateCubic(src2,fpip->max_w,qh,qv);
			dst->cb = src->cb;
			dst->cr = src->cr;

			++dst; ++src; ++bum;
			lo_dispx -= 256;
			hi_dispx -= 256;
		}
		*dst = *src;

		dst += fpip->max_w - fpip->w +1;
		src += fpip->max_w - fpip->w +1;
		bum += fixed_w - fpip->w +1;

		lo_dispy -= 256;
		hi_dispy -= 256;
	}
	//[̂܂܃Rs[
	if (y_end >= fpip->h -1) {
		memcpy(dst,src,fpip->w*sizeof(*dst));
	}
}
//}`Xbh
static void WarpSharp_MT(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER *fp				= ((FILTER_PARAM *)param1)->fp;
	FILTER_PROC_INFO *fpip	= ((FILTER_PARAM *)param1)->fpip;
	short *bum				= (short *)param2;
	
	//摜cɃXbhď͈͌vZ
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = (( fpip->h * (thread_id+1) ) / thread_num) -1;
	
	WarpSharp(bum, fp, fpip, y_start, y_end);
}

#ifdef INTERPOLATECUBIC_SSE2
inline int InterpolateCubic(const short* src,int pitch,const int *qh,const int *qv)
{
	const short* p0 = src;
	const short* p1 = p0 + pitch;
	const short* p2 = p1 + pitch;
	const short* p3 = p2 + pitch;
	int luma;

	p0m = _mm_loadu_i128((__128i *)p0);
	p1m = _mm_loadu_i128((__128i *)p1);
	p2m = _mm_loadu_i128((__128i *)p2);
	p3m = _mm_loadu_i128((__128i *)p3);
	qhm = _mm_setr_epi32(qh[0], qh[1], qh[2], qh[3]);
	qvm = _mm_setr_epi32(qv[0], qv[1], qv[2], qv[3]);

	lum = _mm_setr_epi32(	mm_sum_epi32(mm_mul4_epi32(p0m, qh)), 
							mm_sum_epi32(mm_mul4_epi32(p1m, qh)),
							mm_sum_epi32(mm_mul4_epi32(p2m, qh)),
							mm_sum_epi32(mm_mul4_epi32(p3m, qh))
						);
	luma = mm_sum_epi32(_mm_mul4_epi32(_mm_srri_epi32(_mm_add_epi32(lum, c1024), 11, qvm));

	luma = (luma + (1<<16)) >> 17;
	if (luma < 0)	luma = 0;
	else if (luma > 4096)	luma = 4096;
	
	return luma;
}
#else
/*--------------------------------------------------------------------
*	InterpolateCubic
*-------------------------------------------------------------------*/
inline int InterpolateCubic(const PIXEL_YC* src,int pitch,const int *qh,const int *qv)
{
	const PIXEL_YC* p0 = src;
	const PIXEL_YC* p1 = p0 + pitch;
	const PIXEL_YC* p2 = p1 + pitch;
	const PIXEL_YC* p3 = p2 + pitch;
	int luma;
	
	luma  = ((p0[0].y*qh[0] + p0[1].y*qh[1] + p0[2].y*qh[2] + p0[3].y*qh[3] + 1024) >>11) * qv[0];
	luma += ((p1[0].y*qh[0] + p1[1].y*qh[1] + p1[2].y*qh[2] + p1[3].y*qh[3] + 1024) >>11) * qv[1];
	luma += ((p2[0].y*qh[0] + p2[1].y*qh[1] + p2[2].y*qh[2] + p2[3].y*qh[3] + 1024) >>11) * qv[2];
	luma += ((p3[0].y*qh[0] + p3[1].y*qh[1] + p3[2].y*qh[2] + p3[3].y*qh[3] + 1024) >>11) * qv[3];

	luma = (luma + (1<<16)) >> 17;
	if (luma < -278)	luma = -278;
	else if (luma > 4468)	luma = 4468;
//	if(luma<AviUtlY(0)) luma = AviUtlY(0);
//	else if(luma>AviUtlY(255)) luma = AviUtlY(255);
	
	return luma;
}
#endif

/*--------------------------------------------------------------------
*	NegaPosi	lK|W	(MT)
*-------------------------------------------------------------------*/
static BOOL NegaPosi(FILTER *fp,FILTER_PROC_INFO *fpip, int y_start, int y_end)
{
	PIXEL_YC* ptr1 = fpip->ycp_edit + y_start * fpip->max_w;

	for(int i=y_end - y_start +1; i; --i){
		PIXEL_YC* ptr2 = ptr1;
		for(int j=fpip->w; j; --j){
			ptr2->y  = 4096 - ptr2->y;
			ptr2->cb = -ptr2->cb;
			ptr2->cr = -ptr2->cr;
			++ptr2;
		}
		ptr1 += fpip->max_w;
	}

	return TRUE;
}
//}`Xbh
static void NegaPosi_MT(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER *fp				= (FILTER *)param1;
	FILTER_PROC_INFO *fpip	= (FILTER_PROC_INFO *)param2;

	//摜cɃXbhď͈͌vZ
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = ( fpip->h * (thread_id+1) ) / thread_num -1;
	
	NegaPosi(fp, fpip, y_start, y_end);
}

/*--------------------------------------------------------------------
*	CopyEdge	͈͂̊ORs[
*-------------------------------------------------------------------*/
static void CopyEdge(FILTER *fp,FILTER_PROC_INFO *fpip)
{
	PIXEL_YC* src = fpip->ycp_edit;
	PIXEL_YC* dst = fpip->ycp_temp;
	int i;

	int rowsize = fpip->w*sizeof(PIXEL_YC);

	//㏜O͈͂CRs[
	for(i=fp->track[tTOP];i;--i){
		memcpy(dst,src,rowsize);
		src += fpip->max_w;
		dst += fpip->max_w;
	}
	int rightpitch = fpip->w - fp->track[tRIGHT];
	int right = fp->track[tRIGHT]*sizeof(PIXEL_YC);
	int left  = fp->track[tLEFT]*sizeof(PIXEL_YC);
	//Rs[s=O͈-㏜O͈
	for(i=fpip->h-fp->track[tTOP]-fp->track[tBTM];i;--i){
		PIXEL_YC* src2 = src;
		PIXEL_YC* dst2 = dst;
		//O͈͂Rs[
		memcpy(dst2,src2,left);
		src2 += rightpitch;
		dst2 += rightpitch;
		//EO͈͂Rs[
		memcpy(dst2,src2,right);
		src += fpip->max_w;
		dst += fpip->max_w;
	}
	//O͈͂Rs[
	for(i=fp->track[tBTM];i;--i){
		memcpy(dst,src,rowsize);
		src += fpip->max_w;
		dst += fpip->max_w;
	}

	return;
}

/*====================================================================
*	ݒEBhEvV[W
*===================================================================*/
BOOL func_WndProc( HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam, void *editp, FILTER *fp )
{
	switch(message){
		case WM_KEYUP:	// CEBhE֑
		case WM_KEYDOWN:
//		case WM_MOUSEWHEEL:
			SendMessage(GetWindow(hwnd, GW_OWNER), message, wparam, lparam);
			break;
	}

	return FALSE;
}


#ifdef SSE2
//32rbg4̏Z
inline __m128i mm_mul4_epi32(__m128i a, __m128i b)
{
	__m128i r1 = _mm_mul_epu32(a, b);
	__m128i r2 = _mm_mul_epu32(_mm_srli_si128(a, 4), _mm_srli_si128(b, 4));

	return _mm_setr_epi32(r1.m128i_i32[0], r2.m128i_i32[0], r1.m128i_i32[2], r2.m128i_i32[2]);
}
#endif
